package cz.zweistein.df.soundsense.player;

import java.io.FileInputStream;
import java.io.InputStream;
import java.util.logging.Logger;

import javazoom.jl.player.Player;
import cz.zweistein.df.soundsense.config.Sound;
import cz.zweistein.df.soundsense.util.LoggerSource;


public class PlayerManager {
	private static Logger logger = LoggerSource.logger;
	
	private PlayerThread thread;
	
	public PlayerManager() {
		
		this.thread = new PlayerThread();
		new Thread(thread).start();
		
	}

	public void playSound(Sound sound) {
		
		if (sound.getMusic() == false) {
			newMP3Thread(sound.getSoundFile());
		} else  {
			if (sound.getLoop() == true) {
				thread.setLoopMusic(sound);
			}
			thread.setCurrentMusic(sound.getSoundFile());
			thread.setTemporaryLoopDisable(true);
				
			if (thread.getMusicPlayer() != null) {
				thread.getMusicPlayer().close();
			}
			
		}
		
	}

	public static void newMP3Thread(final String fileName) {
		
		new Thread(new Runnable() {

			@Override
			public void run() {
				try {
					InputStream in = new FileInputStream(fileName);

					Player player = new Player(in);
					
					logger.fine("Playing "+fileName);
					player.play();
					logger.fine("Finished "+fileName);
					
				} catch (Exception e) {
					logger.severe(e.toString());
				}
			}
			
		}).start();
		
	}

}
